!> @file m_common.f90
!! The FishMet Model: Definition of global parameters and
!! computational utilities.

! ------------------------------------------------------------------------------
! Copyright notice:
!   Copyright (c) 2020-2024 Sergey Budaev & Ivar Rønnestad
! FishMet model code is distributed according to GNU AGPL v3, see LICENSE.md
! ------------------------------------------------------------------------------

!> This module defines global parameters and general-level computational
!! utilities.
module COMMONDATA

  use REALCALC
  use, intrinsic :: ISO_FORTRAN_ENV, only : ERROR_UNIT

  implicit none

  !! The include file is generated automatically from the global version
  !! by the Make system. This functionality can be disabled by defining
  !! an appropriate public string parameter `SVN_VERSION_GLOBAL`:
  !! `character(len=*), parameter, public :: SVN_VERSION_GLOBAL = 'disabled'`
  !!
  !! Here is the Makefile macro that produces the version header
  !! @verbatim
  !!   # Version string is  obtained from SVN
  !!   VERSION_STRING := $(shell svn info --show-item last-changed-revision)
  !! @endverbatim
  !include 'version.h' ! autogenerated from svn macro in Makefile
  character(len=*), parameter, public :: SVN_VERSION_GLOBAL = '0.1_o'

  !> Program title that appears on the main interface/window.
  character(len=*), parameter, public :: PROGRAM_TITLE =                      &
                              "FishMet: the fish appetite and feeding model"

  !> Logical flag that sets the DEBUG mode. When the program is running in
  !! the **DEBUG mode**, additional checks are done and more output is
  !! produced.
  logical, parameter, public :: IS_DEBUG = .TRUE.

  !> Compile-time logical flag that defines if stress effects described by
  !! ::global_stress_factor_hour, ::global_stress_fact_suppress  and
  !! ::global_stress_cost_smr
  logical, parameter, public :: IS_STRESS_ENABLE = .TRUE.

  !> Warning level in the debugging mode.
  real(SRP), parameter, public :: DEBUG_WARN_LEVEL = 0.75_SRP

  !> The default length of labels and similar text strings
  integer, parameter, public :: LABEL_LEN = 24

  !> The default length of the file name
  integer, parameter, public :: FILE_NAME_LEN = 255

  !> The minimum length of a data file. Note that cancelled file name dialog
  !! returns a six-char random sequence. Hence the minimum file name > 7
  integer, parameter, public :: MINIMUM_FILENAME_CHARS = 7

  !> Global time constants, number of sec in hour  and min
  integer, parameter, public :: HOUR=3600, MINUTE=60

  !> The maximum number of data points that are plotted for the model
  !! output arrays (squeezed arrays).
  integer, parameter, public :: MAX_POINTS_PLOT = 1000

  !> Global parameter defining if progress bar is printed in the GUI mode.
  logical, parameter, public :: IS_PROGRESS_BAR_GUI = .TRUE.

  !> Maximum value (steps) in the progress bar (minimum is 0)
  integer, parameter, public :: GUI_PROGRESS_BAR_MAX = 100

  !> Number of steps in the progress bar at the GUI mode.
  integer, parameter, public :: GUI_PROGRESS_BAR_STEPS = 100

  !> The symbol used for writing the progress bar in text mode.
  character(len=1), parameter, public :: PROG_BAR_CHAR = "#"

  !> The length of the progress bar in text mode.
  integer, parameter, public :: PROG_BAR_LEN = 42

  ! New line character
  character, parameter, public :: CRLF = char(10)

  !> Global variable that defines the current time step.
  integer(LONG), public :: Global_Time_Step

  !> Default file base-name for saving model output arrays
  character(len=*), parameter, public :: OUTPUT_ARRAYS_CSV_FILE               &
                                              = "model_output_arrays"

  !> Default file base-name for saving model rate data
  character(len=*), parameter, public :: OUTPUT_RATE_DATA_CSV_FILE            &
                                              = "model_rate_data"

  !> Default output directory: all plot and data file will be saved into this
  !! directory by default (local directory) unless reconfigured via
  !! commondata::global_output_dest
  character(len=*), parameter, public :: OUTPUT_DEST_DIR = ""

  !> Output directory: all plot and output files will be saved into this
  !! directory, default value is set by ::output_dest_dir.
  !! Specifically, the following outputs are saved to the `output_dest`
  !! directory:
  !!  - output plots produced by `save` command
  !!   (see if_cmd::cmd_iface_process_commands(), usually set by `setfil()`);
  !!  - output arrays by `save model_output`
  !!    (see simulate::output_arrays_save_csv());
  !!  - rate arrays by `save rate_output`
  !!    (see simulate::output_arrays_save_rate_data_csv());
  !!  - output statistics by `output stats` and `append stats`
  !!    (see if_cmd::cmd_iface_process_commands()).
  !!
  !! @note Note that fish object data `save fish_object_data` is saved into the
  !!       commondata::global_fish_object_binary_file exactly as specified in
  !!       the `fish_object_file` (commondata::global_fish_object_binary_file)
  !!       because this is non-human readable internal binary data not intended
  !!       as the model output.
  !!
  !! @note Note that this parameter affects the program behaviour only
  !!       in the command line user interface (if_cmd) and not in the graphical
  !!       user interface (if_gui).
  !!
  !! @note Note that the destination can refer to destination directory or
  !!       output file name prefix. In the former case it should terminate
  !!       with the operating system specific directory delimiter (e.g. `/` on
  !!       GNU/Linux or `/` on Microsoft Windows). If the value of
  !!       `output_dest` does not terminate this way, it will refer to the
  !!       file prefix.
  !!
  !! @verbatim
  !!   output_dest = "../../../SHARE/data/"
  !! @endverbatim
  character(len=FILE_NAME_LEN), public :: Global_Output_Dest

  !> Defines the name of the file that keeps global parameters.
  !! The parameter file contains the coupled pairs of the parameter
  !! name and its value. Comments can be added, normally separated by
  !! the `#` commet symbol
  !!   @verbatim
  !!     # Stomach mass of the fish, filling capacity
  !!     stomach_capacity = 123.45
  !!     # Water uptake, proportional to food item m
  !!     water_uptake = 0.1
  !!   @endverbatim
  character(len=*), parameter, public :: PARAM_FILE_NAME_DEF = "parameters.cfg"

  !> Defines the name of the file that keeps global parameters.
  !! This name is normally defined by the environment variable
  !! `FFA_MODEL_PARAMETER_FILE` that is processed in runtime::system_init().
  !! If this environment variable is not set, the parameter file name is
  !! defined by the default ::param_file_name_def.
  character(len=FILE_NAME_LEN), public :: Global_Param_File_Name

  ! Global parameters that are obtained from the parameter configuration file
  ! Note that global parameters have GLOBAL_ prefix

  !> Maximum number of food items in the fish stomach, this is the maximum
  !! index for the food items array in the_fish::stomach object.
  !! @warning This index value must always be large enough to ensure maximum
  !!          filling capacity of the fish stomach ::global_stomach_mass in
  !!          units of food items ::Global_Food_Item_Mass given the mass
  !!          of many food items in the array is diminishing to zero.
  !!          MAX_FOOD_ITEMS_INDEX >> stomach_capacity / food_item_mass
  !! @note    Using a fixed size rather than allocatable array makes it easier
  !!          to program, faster runtime (less dynamic memory) and reduces
  !!          stack usage.
  integer, parameter, public :: MAX_FOOD_ITEMS_INDEX = 4000

  !> Global logical flag to suppress extra text diagnostics and messages,
  !! the "quiet mode" or the "verbose mode". If the parameter is TRUE, then
  !! verbose mode is activated.
  logical, public :: Verbose

  !> Definition of time plot scale types for ::global_time_plots_unit_scale
  enum, bind(C)
    enumerator :: SCALE_SEC, SCALE_MIN, SCALE_HOUR, UNSCALED
  end enum

  !> @note Note that scale types are public.
  public :: SCALE_SEC, SCALE_MIN, SCALE_HOUR, UNSCALED

  !> Default rate discretization interval in minutes, this interval is used
  !! to plot the ingestion rate
  !! @verbatim
  !!   rate_interval = 10
  !! @endverbatim
  integer, public :: Global_Rate_Interval

  !> Default duration of the model run in **hours**. Note that parameter
  !! file uses hours as unit. Conversion to time steps is done in
  !! simulate::total_timesteps().
  !! @verbatim
  !!   run_model_hours = 24
  !! @endverbatim
  integer, public ::  Global_Run_Model_Hours

  !> Default hour at which the "daytime" is normally started. This means,
  !! in particular, that at the start of the simulation day starts with the
  !! offset equal to this parameter value.
  !! @verbatim
  !!   day_starts_hour = 4
  !! @endverbatim
  integer, public :: Global_Day_Starts_Hour

  !> The offset (delay) to start feeding at the beginning of the simulation,
  !! Note that the parameter file uses minutes as the unit.
  !! @verbatim
  !!   feed_start_offset = 60
  !! @endverbatim
  integer, public :: Global_Run_Model_Feed_Offset

  !> Default duration of the day time in hours, night duration is defined
  !! as 24 - ::global_hours_day_feeding. Feeding activity occurs only
  !! during the day time and not during the night.
  !! @verbatim
  !!   daytime_hours = 12
  !! @endverbatim
  integer, public :: Global_Hours_Daytime_Feeding

  !> Fish body mass, g, at the start of the simulation
  !! Configuration file example:
  !! @verbatim
  !!   body_mass = 200.0
  !! @endverbatim
  real(SRP), public   :: Global_Body_Mass

  !> Fish stomach mass, max. filling capacity.
  !! Configuration file example:
  !! @verbatim
  !!   stomach_capacity = 24.0
  !! @endverbatim
  real(SRP), public   :: Global_Stomach_Mass

  !> Fish mid-gut mass capacity, max. filling capacity.
  !! Configuration file example:
  !! @verbatim
  !!   midgut_capacity = 24.0
  !! @endverbatim
  real(SRP), public   :: Global_MidGut_Mass

  !> Logical flag that specifies that the stomach and midgut mass (capacity)
  !! are automatically recalculated based on the body mass ::global_body_mass,
  !! possibly overriding the parameter values set by ::global_stomach_mass and
  !! ::global_midgut_mass
  !! @verbatim
  !!   stomach_midgut_automatic = True
  !! @endverbatim
  logical, public :: Global_Stomach_Midgut_Mass_Is_Automatic

  !> Maximum absorption ratio relative to the original dry food item
  !! mass.
  !! Configuration file example:
  !! @verbatim
  !!   absorption_ratio = 0.5
  !! @endverbatim
  real(SRP), public   :: Global_Absorption_Ratio

  !> Delay of ingestion, min
  !! @note Note that the model is discrete, with a single time step
  !!       equivalent to one s
  !! Configuration file example:
  !! @verbatim
  !!  ingestion_delay = 30
  !! @endverbatim
  integer, public     :: Global_Ingestion_Delay_Min

  !> Delay of digestion, min. It is the delay of absorption after a food item
  !! was transmitted to the mid-gut. Any absorption can start only after
  !! the digestion delay.
  !! Configuration file example:
  !! @verbatim
  !!  digestion_delay = 20
  !! @endverbatim
  integer, public     :: Global_Digestion_Delay_Min

  !> The maximum duration a food item can be processed in the fish
  !! mid-gut, min. If it stays in the mid-gut for any longer time, it is
  !! excreted.
  !! Configuration file example:
  !! @verbatim
  !!  midgut_maxdur = 180
  !! @endverbatim
  integer, public     :: Global_Maximum_Duration_Midgut_Min

  !> Proportion of water uptake, relative of dry mass of the food item.
  !! Configuration file example:
  !! @verbatim
  !!  water_uptake = 0.2
  !! @endverbatim
  real(SRP), public   :: Global_Water_Uptake

  !> Parameters of the logistic water uptake function that defines the
  !! temporary pattern of water uptake
  !! `c /(1+a*%e**(-r2*t));` where c is the upper limit of the mass,
  !!  a and r are logistic parameters and %e is natural logarithm base.
  !! Thus, water uptake dynamics is defined by two additional logistic
  !! parameters: `Global_Water_Uptake_A` and `Global_Water_Uptake_R`
  !! @note Maxima plot: `wxplot2d( 0.1/(1+200*%e**(-0.01*x)), [x,0,1900] );`
  !! @verbatim
  !!   water_uptake_a = 200.0
  !! @endverbatim
  real(SRP), public :: Global_Water_Uptake_A

  !> Parameters of the logistic water uptake function that defines the
  !! temporary pattern of water uptake
  !! `c /(1+a*%e**(-r2*t));` where c is the upper limit of the mass,
  !!  a and r are logistic parameters and %e is natural logarithm base.
  !! Thus, water uptake dynamics is defined by two additional logistic
  !! parameters: `Global_Water_Uptake_A` and `Global_Water_Uptake_R`
  !! @note Maxima plot: `wxplot2d( 0.1/(1+200*%e**(-0.01*x)), [x,0,1900] );`
  !! @verbatim
  !!   water_uptake_r = 0.01
  !! @endverbatim
  real(SRP), public :: Global_Water_Uptake_R

  !> Food transport in stomach: Dimensionality of the transport pattern in the
  !! stomach.
  integer, public     :: Global_Transport_Dim
  !> Food transport in stomach: Time grid array for interpolation.
  !! Configuration file example:
  !! @verbatim
  !!  transport_pattern_t =   0 2 8 12
  !! @endverbatim
  integer, allocatable, dimension(:), public     :: Global_Transport_Pattern_T
  !> Food transport in stomach: Proportion of food mass left in stomach.
  !! Configuration file example:
  !! @verbatim
  !!   transport_pattern_r = 1.0 0.9 0.2 0.0
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public   :: Global_Transport_Pattern_R

  !> Temperature adjustment for absorption is controlled by the two
  !! parameters below that define the temperature adfjustment grid factor
  !! for the Michaelis-Menten equation: ::global_temp_factor_midgut_t and
  !! ::global_temp_factor_midgut_m
  !! This parameter provides the temperature grid for
  !! Michaelis-Menten absorption process
  !! @verbatim
  !!   midgut_temp_fact_t = c(5.0, 10.0, 15.0, 25.0)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public   :: Global_Temp_Factor_Midgut_t

  !> The pattern of stress effect on the appetite is described by two grid
  !! arrays ::global_stress_factor_hour and
  !! ::global_stress_fact_suppress
  !! This ::global_stress_factor_hour defines the time grid for the
  !! stress pattern, h
  !! @verbatim
  !!   stress_grid_hour = c(0, 10, 20, 40, 50, 72)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public :: Global_Stress_Factor_Hour

  !> The pattern of stress effect on the appetite is described by two grid
  !! arrays ::global_stress_factor_hour and
  !! ::global_stress_fact_suppress
  !! This ::global_stress_factor_hour defines the time grid for the
  !! stress pattern, h
  !! @verbatim
  !!   stress_grid_fact = c(1.0, 0.9, 0.7, 0.2, 0.1, 0.0)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public   ::                           &
                                              Global_Stress_Fact_Suppress


  !> Maximum value of the metabolic cost of stress in units of resting metabolic
  !! rate (SMR). The real metabilic cost scales depending on the time since
  !! stress intervention following the stress pattern described by the
  !! `stress_grid_hour` and `stress_grid_fact` grid.
  !!
  !! @verbatim
  !!   stress_metabolic_cost = 0.5
  !! @endverbatim
  real(SRP), public :: Global_Stress_Cost_SMR

  !> Maximum value of the suppressive effect of stress on baseline activity.
  !! The actual suppression of the baseline activity scales depending on the
  !! time since stress intervention following the stress pattern described by
  !! the `stress_grid_hour` and `stress_grid_fact` grid.
  !! @verbatim
  !!   stress_inactivity = 0.5
  !! @endverbatim
  real(SRP), public :: Global_Stress_Activity_Decr

  !> Global logical flag setting the time unit for the stress intervention
  !! parameter array defined by ::global_stress_intervention_time. If set
  !! to TRUE, the `stress` parameter is set in minutes, otherwise in raw
  !! seconds.
  !! @verbatim
  !!   stress_is_min = TRUE
  !! @endverbatim
  logical, public :: Global_Stress_Intervention_Is_Minutes

  !> The time of stress intervention is set by this array. It is the start
  !! points of stressful effects (s).
  !! @verbatim
  !!  # Two stress events, at 14h and 64h
  !!  # set in s
  !!   stress = c(50400, 240400)
  !!  # set in min
  !!   stress = c(840, 3840)
  !! @endverbatim
  integer(LONG), allocatable, dimension(:), public ::                         &
                                              Global_Stress_Intervention_Time

  !> Temperature adjustment for absorption is controlled by the two
  !! parameters below that define the temperature adfjustment grid factor
  !! for the Michaelis-Menten equation: ::global_temp_factor_midgut_t and
  !! ::global_temp_factor_midgut_m
  !! This parameter provides the temperature grid for
  !! Michaelis-Menten absorption process
  !! @verbatim
  !!   midgut_temp_fact_m = c(0.4,  0.6, 1.0, 8.0)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public   :: Global_Temp_Factor_Midgut_m

  !> The baseline *temperature* that applies to the stomach transport pattern
  !! defined by ::global_transport_pattern_t and ::global_transport_pattern_r
  !! @verbatim
  !!   transport_pattern_base_temp = 16
  !! @endverbatim
  real(SRP), public :: Global_Transport_Baseline_Temperature

  !> The baseline *fish mass* that applies to the stomach transport pattern
  !! defined by ::global_transport_pattern_t and ::global_transport_pattern_r
  !! @verbatim
  !!   transport_pattern_base_mass = 100
  !! @endverbatim
  real(SRP), public :: Global_Transport_Baseline_Fish_Mass

  !> A data structure that defines the stomach emptying pattern as dependent
  !! on the temperature and the fish mass
  !! @verbatim
  !!         | 50  100  300  500  <--- grid_mass
  !!  -------+-------------------
  !!  5      | 24   35   75  100
  !!  10     | 15   20   50   75
  !!  15     |  9   15   40   50
  !!  20     |  5   10   30   35
  !!  22     |  4    8   29   33
  !!   ^
  !!   +--- grid_temperature
  !! @endverbatim
  type, public:: STOMACH_EMPTYING_PATTERN
    real(SRP), dimension(:), allocatable :: grid_mass
    real(SRP), dimension(:), allocatable :: grid_temperature
    integer, dimension(:,:), allocatable :: emptying_time
  end type STOMACH_EMPTYING_PATTERN

  !> Default stomach emptying pattern
  type(STOMACH_EMPTYING_PATTERN), public :: Global_Stomach_Emptying_Pattern

  !> Fish appetite at night. This value is normally low because the fish do
  !! not feed at night. If the value is absent or negative, fish appetite
  !! does not reduce at night.
  !! @verbatim
  !!   appetite_night=0.1
  !! @endverbatim
  real(SRP), public :: Global_Appetite_Fish_Night

  !> Protective appetite threshold for stomach: this is the maximum value of
  !! the the_fish::stomach::appetite_stomach() when the overall fish appetite
  !! level the_fish::fish::appetite() depends only on stomach filling. Thereby
  !! it can protect stomach from overfilling.
  !! Configuration file example:
  !! @verbatim
  !!   appetite_threshold_stomach = 0.2
  !! @endverbatim
  real(SRP), public :: Global_Appetite_Stomach_Threshold

  !> Logistic function parameter **A** for the appetite factor.
  !! See the_fish::appetite_func().
  !! @verbatim
  !!   appetite_factor_a = 50000.0
  !! @endverbatim
  real(SRP), public :: Global_Appetite_Logist_A

  !> Logistic function parameter **R** for the appetite factor.
  !! See the_fish::appetite_func().
  !! @verbatim
  !!   appetite_factor_r = 20.0
  !! @endverbatim
  real(SRP), public :: Global_Appetite_Logist_R

  !> Michaelis-Meneten food absorption parameter in mid-gut, @f$ r_{max} @f$
  !! (see the_fish::michaelis_menten()) relative to the maximum mass of the
  !! food item, rate is per second (basic discrete step of the model).
  !! @verbatim
  !!   midgut_michaelis_r_max = 0.8
  !! @endverbatim
  real(SRP), public :: Global_Mid_Gut_MM_r_max

  !> Michaelis-Meneten food absorption parameter in mid-gut, @f$ K_M @f$
  !! (see the_fish::michaelis_menten()) relative to the total mid-gut
  !! mass ::global_midgut_mass
  !! @verbatim
  !!   midgut_michaelis_k = 0.25
  !! @endverbatim
  real(SRP), public :: Global_Mid_Gut_MM_K_M

  !> The steepness parameter of the Logistic energy component of appetite
  !! @verbatim
  !!   appetite_energy_rate = 40.0
  !! @endverbatim
  real(SRP), public :: Global_Energy_Appetite_Rate

  !> The shift parameter of the Logistic energy component of appetite
  !! @verbatim
  !!   appetite_energy_shift = 0.2
  !! @endverbatim
  real(SRP), public :: Global_Energy_Appetite_Shift

  !> Activity appetite factor determining how fish locomotor activity
  !! increases with increasing appetite. See
  !! the_fish::fish_activity_appetite_factor()
  !! @verbatim
  !!   activity_appetite_factor = 0.5
  !! @endverbatim
  real(SRP), public :: Global_Appetite_Activity_Factor

  !> A parameter defining branchial and urine (ZE+UE) energy consumption
  !! as a factor to SMR, e.g. 0.3 means (UE+ZE) = 0.3*SMR
  !! @note Note that this is the default method.
  !! @verbatim
  !!   branchial_energy_factor = 0.3
  !! @endverbatim
  real(SRP), public :: Global_UE_ZE_Factor

  !> A parameter defining branchial and urine (ZE+UE) energy consumption
  !! as a fixed ammonia excretion rate, micro (\mu) mol per g body mass
  !! per hour
  !! @verbatim
  !!   branchial_ammonia_rate = 0.5
  !! @endverbatim
  real(SRP), public :: Global_UE_ZE_Ammonia_Excretion

  !> Logical flag to choose how branchial and urinal (ZE+UE) energy loss is
  !! calculated.
  !!  - If this parameter is TRUE, fixed rate is assumed as defined by
  !!    ::global_ue_ze_ammonia_excretion
  !!  - if it is FALSE, a fraction of SMR defined by ::global_ue_ze_factor
  !!    is used for calculation. This method is the default.
  !!  .
  logical, public :: Global_IS_UE_ZE_Fixed_Rate

  !> Defines the specific dynamic action (SDA) that depends on the absorption
  !! rate. There are two parameters that define the linear relationship between
  !! absorption rate and SDA increase. This parameter defines the maximum
  !! absorption rate when the maximum SDA (defined by `sda_energy_factor_max`)
  !! is reached.
  !! @verbatim
  !!   sda_absorption_rate_max = 0.0007
  !! @endverbatim
  real(SRP), public :: Global_SDA_Absorp_Rate_Max

  !> Defines the specific dynamic action (SDA) that depends on the absorption
  !! rate. There are two parameters that define the linear relationship between
  !! absorption rate and SDA increase. This parameter defines the maximum SDA
  !! reached at the maximum absorption rate defined by
  !! `sda_absorption_rate_max`.
  !! For example, this parameter equal to 2.0 means that SDA = SMR * 2.0 at the
  !! maximum absorption rate.
  !! @verbatim
  !!   sda_energy_factor_max = 2.0
  !! @endverbatim
  real(SRP), public :: Global_SDA_Factor_Max

  !> This parameter defines the X axis of the grid: temperature.
  !! See commondata::oxygen_rate_std() for details. If the array is not
  !! defined in the configuration file, use
  !! commondata::trout_oxygen_grid_x_temp
  !! Configuration file example:
  !! @verbatim
  !!  smr_oxygen_temp = c(0.0, 0.5, 5.1, 15.2, 20.2, 25.2, 26.2)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public :: Global_Oxygen_Grid_X_Temp

  !> This parameter defines the Y axis of the grid: oxygen consumption.
  !! See commondata::oxygen_rate_std() for details. If the array is not
  !! defined in the configuration file, use
  !! commondata::trout_oxygen_grid_y_o2std
  !! Configuration file example:
  !! @verbatim
  !!  smr_oxygen_o2 = c(38.0, 38.0, 40.6, 67.8, 94.6, 136.7, 145.9)
  !! @endverbatim
  real(SRP), allocatable, dimension(:), public :: Global_Oxygen_Grid_Y_O2std

  !> Standard mass of one food item.
  !! Configuration file example:
  !! @verbatim
  !!  food_item_mass = 2.0
  !! @endverbatim
  real(SRP), public   :: Global_Food_Item_Mass

  !> Gross energy content of the feed, MJ/kg (=kJ7g)
  !! Configuration file example:
  !! @verbatim
  !!  feed_gross_energy = 23.0
  !! @endverbatim
  real(SRP), public   :: Global_Food_Gross_Energy

  !> Minimum mass of food item that counts as non-zero,
  !! a tolerance limit
  real(SRP), parameter, public :: MIN_MASS_TOLER = 0.0001_SRP

  !> Ambient temperature
  !! Configuration file example:
  !! @verbatim
  !!  temperature = 16.0
  !! @endverbatim
  real(SRP), public :: Global_Temperature

  !> Standard rate of food item input, per minute.
  !! Configuration file example:
  !! @verbatim
  !!  food_input_rate = 6.0
  !! @endverbatim
  real(SRP), public   :: Global_Food_Input_Rate

  !> Parameters of the food provisioning pattern:
  !!  - interval food **is** provided, min
  !!  - interval food is **not** provided interval, min
  !! .
  !! These parameters determine the ::global_interval_food_pattern logical
  !! array for each time step.
  !! @verbatim
  !!  food_provision_pattern = 10 20
  !! @endverbatim
  integer, dimension(2), public :: Global_Interval_Food_Param

  !> Global food provisioning pattern, logical TRUE/FALSE for each time step.
  logical, allocatable, dimension(:), public :: Global_Interval_Food_Pattern

  !> Global variable that keeps the file name for the food provisioning pattern
  !! see environ::food_provisioning_get_file() for more details.
  !! @note Note that the file has priority over the food provisioning pattern
  !!       defined in ::global_interval_food_param.
  !! @verbatim
  !!  food_provision_file_name = "../zzz.csv"
  !! @endverbatim
  character(len=FILE_NAME_LEN), public :: Global_Food_Pattern_File

  !> Global logical flag that defines if the feed scheduling pattern defined
  !! by the ::global_interval_food_pattern file will propagate to all 24 h
  !! periods or applied just once to the first such period.
  !! @verbatim
  !!  food_provision_file_repeat = TRUE
  !! @endverbatim
  logical, public :: Global_Food_Pattern_File_Is_Propagate

  !> Global logical flag that defines if the feed scheduling pattern defined
  !! by the ::global_food_pattern_file file represents the data for each time
  !! step (s) (if TRUE) or by minute (FALSE). The default value is FALSE i.e.
  !! data are given for each minute.
  !! @verbatim
  !!  food_provisioning_file_by_s = FALSE
  !! @endverbatim
  logical, public :: Global_Food_Pattern_File_Is_Steps

  !> Global baseline locomotor activity pattern  (swimming speed) for each
  !! time step consists of two components:
  !!  - baseline that differs at day ::global_baseline_activity_day and
  !!    night ::global_baseline_activity_night
  !!  - feeding activity increment defined by feeding activity factor
  !!    ::global_feeding_activity_factor
  !!  .
  !!
  !! This is illustrated by the following diagram:
  !!
  !! @verbatim
  !!                       +----+   feeding activity multiplier
  !!                       |    |
  !!                    +--+ - -+----------------+
  !!                    |                        |                     baseline
  !! -------------------+                        +-------------------> activity
  !! -night-------------+-day--------------------+-night------------->
  !! @endverbatim
  !!
  !! see the_fish::fish_activity_baseline() for more details.
  !!
  !! @verbatim
  !!  baseline_activity_day = 4.0
  !!  baseline_activity_night = 0.5
  !! @endverbatim
  real(SRP), public ::  Global_Baseline_Activity_Day,                         &
                        Global_Baseline_Activity_Night

  !> Locomotor activity multiplier factor for the activity during the feeding
  !! time, i.e. when ::global_interval_food_pattern is TRUE.
  real(SRP), public :: Global_Feeding_Activity_Factor

  !> Global variable keeping the file name for saving general simulation
  !! statistics. Data (rows) for each simulation run are normally appended
  !! to this file. The data format is CSV.
  !! See simulate::model_output_stats_row_csv() for some details.
  !! @verbatim
  !!   stats_output_file = fishmet_stats.csv
  !! @endverbatim
  character(len=FILE_NAME_LEN), public :: Global_Stats_Output_File


  !> Global variable keeping the file name for the baseline stomach emptying
  !! matrix file that keeps the stomach emptying times for fish of
  !! different mass and at different temperatures. The file should be
  !! prepared in the CSV format and have the following structure:
  !! TODO
  !! @verbatim
  !!   stomach_emptying_matrix = fishmet_stom_data.csv
  !! @endverbatim
  character(len=FILE_NAME_LEN), public :: Global_Stomach_Emptying_Matrix_File

  !> Define if the output stats are saved using the long or short format. In
  !! the first case, both the input parameters and the output stats are
  !! saved/appended into the CSV file. Note that the default value is TRUE.
  !! @verbatim
  !!   stats_output_long = TRUE
  !! @endverbatim
  logical, public :: Global_Output_Stats_Is_Long

  !> Default value of the general simulation statistics file defined in
  !! commondata::global_stats_output_file
  character(len=*), parameter, public :: DEF_STATS_OUTPUT_FILE =              &
                                                      "fishmet_stats.csv"
  !> Natural logarithm base, `e`
  real(SRP), parameter, public :: BASE_E = 2.7182818284590451_SRP

  ! *Rainbow trout* default parameters that are normally unchanged in the model

  !> Interpolation grid defining the function calculating standard oxygen
  !! consumption in rainbow trout based on the curve from Fig. 9 in
  !! Evans, D.O. (1990) Metabolic Thermal compensation by rainbow trout:
  !! effects on standard metabolic rate and potential usable power.
  !! Trans. Am. Fish. Soc. 119, 585–600-
  !!
  !! Interpolation data from Evan 1990:
  !!@verbatim
  !!  [0.0 0.5 5.1 15.2 20.2 25.2 26.2] \
  !!  [38.0 38.0 40.6 67.8 94.6 136.7 145.9]
  !!@endverbatim
  !!
  !! This parameter defines the X axis of the grid: temperature.
  !! See commondata::oxygen_rate_std() for details.
  real(SRP), dimension(*), parameter :: TROUT_OXYGEN_GRID_X_TEMP =            &
      [ 0.0_SRP,  0.5_SRP,  5.0_SRP, 15.2_SRP, 20.1_SRP,  25.2_SRP,  26.2_SRP]

  !> Interpolation grid defining the function calculating standard oxygen
  !! consumption in rainbow trout based on the curve from Fig. 9 in
  !! Evans, D.O. (1990) Metabolic Thermal compensation by rainbow trout:
  !! effects on standard metabolic rate and potential usable power.
  !! Trans. Am. Fish. Soc. 119, 585–600-
  !!
  !! Interpolation data from Evan 1990:
  !!@verbatim
  !!  [0.0 0.5 5.1 15.2 20.2 25.2 26.2] \
  !!  [38.0 38.0 40.6 67.8 94.6 136.7 145.9]
  !!@endverbatim
  !!
  !! This parameter defines the Y axis of the grid: oxygen consumption.
  !! See commondata::oxygen_rate_std() for details.
  real(SRP), dimension(*), parameter :: TROUT_OXYGEN_GRID_Y_O2STD  =          &
      [38.0_SRP, 38.0_SRP, 40.6_SRP, 67.8_SRP, 94.6_SRP, 136.7_SRP, 145.9_SRP]

  !> Time scale abbreviation strings for Y axes of output plots
  character(len=*), parameter, public :: TXT_SEC="s",TXT_MIN="min",TXT_HOUR="h"

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  !> Public interface for the cum2rate function that calculates rate from
  !! raw cumulative array. Note that rate unit time is defined by the
  !! `integer` rate_unit argument (as default, per commondata::minute).
  !! For details see ::cum2rate_int() and ::cum2rate_r().
  interface cum2rate
    module procedure cum2rate_int
    module procedure cum2rate_r
  end interface cum2rate

  !-----------------------------------------------------------------------------
  !> Simple history stack function, add to the end of the stack. We need
  !! only to add components on top (end) of the stack and retain
  !! `HISTORY_SIZE_SPATIAL` elements of the prior history (for a spatial moving
  !! object). The stack works as follows, assuming 100 and 200 are added:
  !! @n                 [1 2 3 4 5 6 7  8   9  10]
  !! @n                 [2 3 4 5 6 7 8  9  10 **100**]
  !! @n                 [3 4 5 6 7 8 9 10 100 **200**]
  interface add_to_history
    module procedure add_to_history_i4
    module procedure add_to_history_r
    module procedure add_to_history_char
  end interface add_to_history

  !> Return the last element of a history array with optional offset.
  interface last
    module procedure last_in_history_i4
    module procedure last_in_history_r
    module procedure last_in_history_char
  end interface last

  !> Function calculating standard oxygen consumption in rainbow trout
  !! based on the curve from Fig. 9 in
  !! Evans, D.O. (1990) Metabolic Thermal compensation by rainbow trout:
  !! effects on standard metabolic rate and potential usable power.
  !! Trans. Am. Fish. Soc. 119, 585–600
  !! @note Note that `oxygen_rate_std` is implemented in both array
  !!       and scalar versions.
  interface oxygen_rate_std
    module procedure oxygen_rate_std_spline
    module procedure oxygen_rate_std_ddpi
  end interface oxygen_rate_std

  !> Function for calculating specific growth rate
  interface SGR
    module procedure SGR_r
    module procedure SGR_i
    module procedure SGR_blockrate
  end interface

  !> Force a value within the range set by the vmin and vmax dummy parameter
  !! values.
  interface within
    module procedure within_i
    module procedure within_r
  end interface within
  ! @note Note that all component procedures are private.

  ! @note Note that all component procedures are private.
  private :: add_to_history_i4, add_to_history_r, add_to_history_char,        &
             last_in_history_i4, last_in_history_r, last_in_history_char,     &
             oxygen_rate_std_spline, oxygen_rate_std_ddpi, SGR_r, SGR_i,      &
             SGR_blockrate, within_i, within_r

contains

  !> Produce a text string containing all global parameters of the model
  impure function model_parameters_txt () result ( message_show )
    use BASE_UTILS, only: TOSTR

    character(len=:), allocatable :: message_show

    character(len=500) :: msg_line
    character(len=LABEL_LEN) :: yes_no_descr, f_min_s_descr, f_exist_descr
    logical :: is_okay

    character(len=*), parameter :: FMT_REAL="f9.3",FMT_RSRT="f8.2",FMT_INT="I9"
    character(len=*), parameter :: FMT_REAL_LON="f14.3"
    character(len=:), allocatable :: fmtstr, label_stats

    message_show = CRLF // " GLOBAL PARAMETERS" // CRLF

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Run duration, hours ('run_model_hours'): ",      &
                                                Global_Run_Model_Hours
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Day start offset, hours ('day_starts_hour'): ",  &
                                                Global_Day_Starts_Hour
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Daytime duration, hours ('daytime_hours'): ",    &
                                                Global_Hours_Daytime_Feeding
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Temperature ('temperature'): ",                  &
                                                Global_Temperature
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Body mass ('body_mass'): ", Global_Body_Mass
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Stomach mass ('stomach_capacity'): ",            &
                                                Global_Stomach_Mass
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Mid-gut mass ('midgut_capacity'): ",             &
                                                Global_MidGut_Mass
    message_show = message_show // CRLF // trim(msg_line)

    if (Global_Stomach_Midgut_Mass_Is_Automatic) then
      label_stats = " YES"
    else
      label_stats = "  NO"
    end if
    message_show = message_show // CRLF //                                    &
          " Stomach/midgut capacity auto (`stomach_midgut_automatic`): " //   &
                                                                    label_stats

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Absorption ratio ('absorption_ratio'): ",        &
                                                Global_Absorption_Ratio
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Delay after ingestion, min (ingestion_delay): ", &
                                                Global_Ingestion_Delay_Min
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Water Uptake ('water_uptake'): ",                &
                                                Global_Water_Uptake
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Water Uptake logistic a ('water_uptake_a'): ",   &
                                                Global_Water_Uptake_A
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Water Uptake logistic r ('water_uptake_r'): ",   &
                                                Global_Water_Uptake_R
    message_show = message_show // CRLF // trim(msg_line)

    write(msg_line,"(a)") " Transport pattern in stomach " //                 &
                          "('transport_pattern_t','transport_pattern_r'):"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr="(a,t14,a,"//TOSTR(size(Global_Transport_Pattern_T))//"I8"//",a)"
    write(msg_line,fmtstr) "  Grid X: ", "[", Global_Transport_Pattern_T, " ]"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr="(a,t14,a,"//TOSTR(size(Global_Transport_Pattern_R))//FMT_RSRT//",a)"
    write(msg_line,fmtstr) "  Grid Y: ", "[", Global_Transport_Pattern_R, " ]"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t51," // FMT_REAL_LON // ")"
    write(msg_line,fmtstr) " Appetite logistic a ('appetite_factor_a'): ",    &
                                              Global_Appetite_Logist_A
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) " Appetite logistic r ('appetite_factor_r'): ",    &
                                              Global_Appetite_Logist_R
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                   " Appetite at night ('appetite_night'): ",                 &
                                              Global_Appetite_Fish_Night
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                   " Appetite threshold ('appetite_threshold_stomach'): ",    &
                                              Global_Appetite_Stomach_Threshold
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                   " Activity appetite factor ('activity_appetite_factor'): ",&
                                              Global_Appetite_Activity_Factor
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Digestion Delay, min ('digestion_delay'): ",     &
                                              Global_Digestion_Delay_Min
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_INT // ")"
    write(msg_line,fmtstr) " Max. duration in mid-gut, h ('midgut_maxdur'): ",&
                                              Global_Maximum_Duration_Midgut_Min
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                    " Energy appetite steepness ('appetite_energy_rate'): ",  &
                                              Global_Energy_Appetite_Rate
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                    " Energy appetite steepness ('appetite_energy_shift'): ", &
                                              Global_Energy_Appetite_Shift
    message_show = message_show // CRLF // trim(msg_line)

    write(msg_line,"(a)") " Mid-gut Michaelis-Meneten absorption constants:"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // "f9.7" // ")"
    write(msg_line,fmtstr) "  r_max ('midgut_michaelis_r_max'): ",            &
                                              Global_Mid_Gut_MM_r_max
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr) "  K_M ('midgut_michaelis_k'): ",                  &
                                              Global_Mid_Gut_MM_K_M
    message_show = message_show // CRLF // trim(msg_line)

    write(msg_line,"(a)") " Michaelis-Meneten temperature adjustment grid:"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t26,a," // TOSTR(size(Global_Temp_Factor_Midgut_t)) //       &
                                                              FMT_RSRT // ",a)"
    write(msg_line,fmtstr) "  'midgut_temp_fact_t': ", "[",                   &
                                              Global_Temp_Factor_Midgut_t, " ]"
    message_show = message_show // CRLF // trim(msg_line)
    !
    fmtstr = "(a,t26,a," // TOSTR(size(Global_Temp_Factor_Midgut_m)) //       &
                                                              FMT_RSRT // ",a)"
    write(msg_line,fmtstr) "  'midgut_temp_fact_m': ", "[",                   &
                                              Global_Temp_Factor_Midgut_m, " ]"
    message_show = message_show // CRLF // trim(msg_line)

    write(msg_line,"(a)") " SMR function ('smr_oxygen_temp', 'smr_oxygen_o2'):"
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t14,a," // TOSTR(size(Global_Oxygen_Grid_X_Temp)) //         &
                                                              FMT_RSRT // ",a)"
    write(msg_line,fmtstr) "  Grid X: ", "[", Global_Oxygen_Grid_X_Temp, " ]"
    message_show = message_show // CRLF // trim(msg_line)
    !
    fmtstr = "(a,t14,a," // TOSTR(size(Global_Oxygen_Grid_Y_O2std)) //        &
                                                              FMT_RSRT // ",a)"
    write(msg_line,fmtstr) "  Grid Y: ", "[", Global_Oxygen_Grid_Y_O2std, " ]"
    message_show = message_show // CRLF // trim(msg_line)

   if (Global_IS_UE_ZE_Fixed_Rate) then
    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                " Branchial/urine ('branchial_ammonia_rate'):  ",             &
                Global_UE_ZE_Ammonia_Excretion
    message_show = message_show // CRLF // trim(msg_line)
   else
    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                " Branchial/urine ('branchial_energy_factor'):  ",            &
                Global_UE_ZE_Factor
    message_show = message_show // CRLF // trim(msg_line)
   end if

    fmtstr = "(a,t57," // "f8.6" // ")"
    write(msg_line,fmtstr)                                                    &
                " SDA absorp. ('sda_absorption_rate_max'):  ",                &
                Global_SDA_Absorp_Rate_Max
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                " SDA max level ('sda_energy_factor_max'):  ",            &
                Global_SDA_Factor_Max
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                    " Baseline day activity ('baseline_activity_day'):  ",    &
                    Global_Baseline_Activity_Day
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // FMT_REAL // ")"
    write(msg_line,fmtstr)                                                    &
                    " Baseline night activity ('baseline_activity_night'):  ",&
                    Global_Baseline_Activity_Night
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t56," // "f9.4" // ")"
    write(msg_line,fmtstr) " Food item mass ('food_item_mass'):  ",           &
                                              Global_Food_Item_Mass
    message_show = message_show // CRLF // trim(msg_line)

    fmtstr = "(a,t40," // FMT_REAL // ",a," // "I3" //  ",a)"
    write(msg_line,fmtstr) " Food input rate ('food_input_rate'): ",          &
                                              Global_Food_Input_Rate,         &
                    "/min = every ", rate2int(Global_Food_Input_Rate), " s"
    message_show = message_show // CRLF // trim(msg_line)

    ! Print either food provision pattern or provision data file
    if ( Global_Food_Pattern_File == "" ) then

      fmtstr = "(a,t56,a," // TOSTR(size(Global_Interval_Food_Param)) // "i8" &
                           // ",a)"
      write(msg_line,fmtstr) " Food scheduling ('food_provision_pattern'): ", &
                                          "[", Global_Interval_Food_Param, " ]"
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t56," // FMT_INT // ")"
      write(msg_line,fmtstr) " Offset to start feeding, min " //              &
                        "('feed_start_offset'):", Global_Run_Model_Feed_Offset
      message_show = message_show // CRLF // trim(msg_line)

    else

      if ( Global_Food_Pattern_File_Is_Propagate ) then
        yes_no_descr = " all 24h periods)"
      else
        yes_no_descr = " apply once)"
      end if

      if ( Global_Food_Pattern_File_Is_Steps ) then
        f_min_s_descr = " (by s"
      else
        f_min_s_descr = " (by min"
      end if

      inquire( file=Global_Food_Pattern_File, exist=is_okay )

      if ( is_okay ) then
        f_exist_descr = ""
      else
        f_exist_descr = " NO FILE"
      end if

      write(msg_line,"(5a)") " Food provision scheduling from file: ",        &
                      trim(Global_Food_Pattern_File), trim(f_min_s_descr),    &
                      trim(yes_no_descr), trim(f_exist_descr)
      message_show = message_show // CRLF // trim(msg_line)

      if ( .not. is_okay ) then
        fmtstr = "(a,t30,a," // TOSTR(size(Global_Interval_Food_Param)) //    &
                                                                  "i8" // ",a)"
        write(msg_line,fmtstr) " Food provisioning schedule: ", "[",          &
                               Global_Interval_Food_Param, " ]"
        message_show = message_show // CRLF // trim(msg_line)

        fmtstr = "(a,t30," // FMT_INT // ")"
        write(msg_line,fmtstr) " Offset to start feeding, min:",              &
                                                Global_Run_Model_Feed_Offset
        message_show = message_show // CRLF // trim(msg_line)
      end if

    end if

    if ( is_stress() ) then
      write(msg_line,"(a)") " Stress parameters:"
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t56," // FMT_REAL // ")"
      write(msg_line,fmtstr) "  'stress_metabolic_cost': ",                   &
                                                  Global_Stress_Cost_SMR
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t56," // FMT_REAL // ")"
      write(msg_line,fmtstr) "  'stress_inactivity': ",                       &
                                                  Global_Stress_Activity_Decr
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t26,a," // TOSTR(size(Global_Stress_Intervention_Time)) // &
                                                              FMT_INT // ",a)"
      if (Global_Stress_Intervention_Is_Minutes) then
        write(msg_line,fmtstr) "  'stress' (min): ", "[",                     &
                                Global_Stress_Intervention_Time / MINUTE, " ]"
      else
        write(msg_line,fmtstr) "  'stress' (s): ", "[",                       &
                                Global_Stress_Intervention_Time, " ]"
      end if
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t26,a," // TOSTR(size(Global_Stress_Factor_Hour)) //       &
                                                              FMT_REAL // ",a)"
      write(msg_line,fmtstr) "  'stress_grid_hour: ", "[",                    &
                                  Global_Stress_Factor_Hour, " ]"
      message_show = message_show // CRLF // trim(msg_line)

      fmtstr = "(a,t26,a," // TOSTR(size(Global_Stress_Fact_Suppress)) //     &
                                                              FMT_REAL // ",a)"
      write(msg_line,fmtstr) "  'stress_grid_fact: ", "[",                    &
                                  Global_Stress_Fact_Suppress, " ]"
      message_show = message_show // CRLF // trim(msg_line)
    end if

    message_show = message_show // CRLF

    message_show = message_show // CRLF //  " Config file: '" //              &
                                            trim(Global_Param_File_Name) // "'"

    message_show = message_show // CRLF //                                    &
                            " Output destination ('output_dest'): '" //       &
                                            trim(Global_Output_Dest) // "'"

    if (Global_Output_Stats_Is_Long) then
      label_stats = " [long]"
    else
      label_stats = " [short]"
    end if

    message_show = message_show // CRLF //  " Global output stats file: '" // &
                          trim(Global_Stats_Output_File) // "'" // label_stats

    if (IS_DEBUG) write(msg_line,"(a)") " Running in the DEBUG mode;"
    message_show = message_show // CRLF // CRLF // trim(msg_line)

    fmtstr = "(2a)"
    write(msg_line,fmtstr) " Version information: ", SVN_VERSION_GLOBAL
    message_show = message_show // trim(msg_line)

    message_show = message_show // CRLF

  end function model_parameters_txt

  !> Calculate if stress factor grid is enabled. Stress is disabled if
  !! *any* of the stress parameters are *not defined*; this includes the
  !! stress suppression grid array or the stress intervention array
  pure function is_stress() result (is_enabled)
    logical :: is_enabled

    if ( (.not. IS_STRESS_ENABLE) .or.                                        &
         any(Global_Stress_Factor_Hour == MISSING) .or.                       &
         any(Global_Stress_Fact_Suppress == MISSING) .or.                     &
         any(Global_Stress_Intervention_Time  == UNKNOWN) .or.                &
         Global_Stress_Cost_SMR == MISSING .or.                               &
         Global_Stress_Activity_Decr == MISSING            ) then
      is_enabled = .FALSE.
    else
      is_enabled = .TRUE.
    end if

  end function is_stress

  !> Logistic function is defined by the equation
  !! @f[ \frac{c}{1+a \cdot e^{-r \cdot x}} @f]
  elemental function logistic( X, A, C, R ) result (Y)
    real(SRP), intent(in) :: X
    real(SRP), intent(in) :: A
    real(SRP), intent(in) :: C
    real(SRP), intent(in) :: R
    real(SRP) :: Y

    Y = C / ( 1.0_SRP + A * BASE_E **(-R*X) )

  end function logistic

  !> Michaelis-Meneten function:
  !! @f[  y = \frac{r_{max} x}{K_M + x}  @f]
  !! Here @f$ r_{max} @f$ is the maximum rate, @f$ K_M @f$ is the Michaelis
  !! constant equal to the x at which 1/2 of the maximum rate @f$ r_{max} @f$
  !! is reached.
  !!
  !! *gnupolot code:*
  !! @verbatim
  !!   set xrange [0:1]
  !!   plot 0.8*x/(0.25+x)
  !! @endverbatim
  elemental function michaelis_menten( x, r_max, x50 ) result ( r )
    !> Independent variable.
    real(SRP), intent(in) :: x
    !> @f$ r_{max} @f$ constant.
    real(SRP), intent(in) :: r_max
    !> The Michaelis constant @f$ K_M @f$.
    real(SRP), intent(in) :: x50
    !> Output response rate.
    real(SRP) :: r

    r = r_max * x / (x50 + x)

  end function michaelis_menten

  !> Calculate temperature adjustment factor for the Michaelis-Menten
  !! absorption process in the midgut.
  !! The function is based on the cubic spline approcimation using the
  !! grid vectors defined by commondata::global_temp_factor_midgut_t and
  !! commondata::global_temp_factor_midgut_t.
  elemental function midgut_temp_factor(temperature)  result (afact)
    use BASE_UTILS, only : CSPLINE_SCALAR
    real(SRP), optional, intent(in) :: temperature
    real(SRP) :: afact

    real(SRP) :: temp_loc

    if (present(temperature)) then
      temp_loc = temperature
    else
      temp_loc = Global_Temperature
    end if

    afact = CSPLINE_SCALAR( Global_Temp_Factor_Midgut_t,                      &
                            Global_Temp_Factor_Midgut_m, temp_loc )

  end function midgut_temp_factor

  !> Calculate the energy content of a feed mass.
  !! @note Units correspondence: mass in kg corresponds to energy in MJ,
  !!       mass in g corresponds to kJ.
  elemental function feed_energy (feed_mass, gross_energy,                    &
                          is_adjust_water_uptake, water_uptake) result (energy)
    !> The mass of the feed, kg
    real(SRP), intent(in) :: feed_mass
    !> Gross energy content of the feed, MJ/kg (=kJ/g)
    real(SRP), intent(in), optional :: gross_energy
    !> Optional logical parameter indicating if the energy content of the
    !! feed is adjusted for water uptake. If TRUE, the energy content of feed
    !! @f$ F( \Delta a ) @f$ is adjusted by subtracking the water added:
    !! @f$ F( \Delta a ) = E_G \Delta a - E_G \Delta a \times u @f$.
    !! The default value is TRUE.
    logical, intent(in), optional :: is_adjust_water_uptake
    !> Optional water uptake coefficient, if absent, the degault value is
    !! taken from ::global_water_uptake.
    real(SRP), intent(in), optional :: water_uptake
    !> Energy content of the input feed mass, MJ
    real(SRP) :: energy

    logical:: is_adjust_loc
    real(SRP) :: water_uptake_loc

    if (present(is_adjust_water_uptake)) then
      is_adjust_loc = is_adjust_water_uptake
    else
      is_adjust_loc = .TRUE.
    end if

    if (present(water_uptake)) then
      water_uptake_loc = water_uptake
    else
      water_uptake_loc = Global_Water_Uptake
    end if

    ! @f$ \Delta a ) = E_G \Delta a @f$
    if (present(gross_energy)) then
      energy = feed_mass * gross_energy
    else
      energy = feed_mass * Global_Food_Gross_Energy
    end if

    ! If adjustment for uptake is used,
    ! @f$ \Delta a ) = E_G \Delta a - E_G \Delta a \times u @f$
    if (is_adjust_loc) then
      energy = energy - energy * water_uptake_loc
    end if

  end function feed_energy

  !> Calculate the enegretic equivalent (kJ) of Oxygen uptake (l O2)
  !! Source: Rønnestad B291.
  elemental function energy_o2(l_o2) result (energy_kj)
    !> Mass of oxygen, l
    real(SRP), intent(in) :: l_o2
    !> Energy equivalent, kJ
    real(SRP) ::  energy_kj

    energy_kj = 19.4_SRP * l_o2

  end function energy_o2

  !> Calculate the mass of 1 dm3 (l) of Oxygen.
  !!
  !! Based on this: 1 mol (22.4l) O2 is 32g, therefore, 1l = 1.43g
  elemental function o2mass(vol_l) result (mass_g)
    !> Volume of oxygen, l
    real(SRP), intent(in) :: vol_l
    !> Mass of oxygen, g
    real(SRP) :: mass_g
    real(SRP), parameter :: RATIO = 32.0_SRP / 22.4_SRP  ! 1.4285714

    mass_g = RATIO * vol_l

  end function o2mass

  !> Calculate the volume of 1 dm3 (l) of oxygen.
  elemental function o2vol(mass_g) result (vol_l)
    !> Mass of oxygen, g
    real(SRP), intent(in) :: mass_g
    !> Volume of oxygen, l
    real(SRP) :: vol_l
    real(SRP), parameter :: RATIO = 22.4_SRP / 32.0_SRP  !  0.7

    vol_l = mass_g * RATIO

  end function o2vol

  !> The function converts rate per min to interval in seconds.
  elemental function rate2int(rate_min) result (n_sec)
    !> Optional rate per minute. Default value is set by
    !! commondata::global_food_input_rate.
    real(SRP), optional, intent(in) :: rate_min
    !> returns interval in seconds between successive events (i.e. every N sec).
    integer(LONG) :: n_sec

    real(SRP) :: rate_min_loc

    if (present(rate_min)) then
      rate_min_loc = rate_min
    else
      rate_min_loc = Global_Food_Input_Rate
    end if

    !> The main equation is @f$ n = \frac{60}{r_{min}} @f$, where
    !! @f$ n @f$ is the interval (s) and @f$ r_{min} @f$ is the rate
    !! per minute.
    !!
    !! Then, to do something every n seconds is implemented as
    !! @code
    !! if ( mod( time_step, rate2int( rate ) )==0 ) then
    !! @endcode
    n_sec = nint( MINUTE/rate_min_loc, LONG )

  end function rate2int


  !> Given an in put array of cumulative sum, this function calculates the
  !! rate per unit time defined by the rate_unit argument (as default,
  !! per commondata::minute). This requires working on  the appropriate
  !! difference values for each time interval.
  !! Note: This function version accepts *integer* array.
  pure function cum2rate_int( inarray, rate_unit ) result(rate_out)
    !> Input Output_Arrays array (integer type)
    integer, dimension(:), intent(in) :: inarray
    !> Optional rate parameter, the rate is calculated per this number of
    !! seconds, the default is per minute
    integer, intent(in), optional :: rate_unit

    real(SRP), dimension(:), allocatable :: rate_out

    integer :: rate_unit_loc, oarray_max, sum_rate, i, j

    if (present(rate_unit)) then
      rate_unit_loc = rate_unit
    else
      rate_unit_loc = MINUTE
    end if

    oarray_max = size(inarray)   ! Output_Arrays
    allocate( rate_out(oarray_max/rate_unit_loc) )

    j = 0
    sum_rate = inarray(1)

    do i=2, oarray_max
      if( inarray(i) > inarray(i-1) ) then
        sum_rate = sum_rate + inarray(i) - inarray(i-1)
      end if
      if (mod(i,rate_unit_loc)==0) then
        j = j + 1
        rate_out(j) = real(sum_rate,SRP) / real(rate_unit_loc,SRP)
        sum_rate = 0
      end if
    end do

  end function cum2rate_int

  !> Given an in put array of cumulative sum, this function calculates the
  !! rate per unit time defined by the rate_unit argument (as default,
  !! per commondata::minute). This requires working on  the appropriate
  !! difference values for each time interval.
  !! Note: This function version accepts *real* array (::srp).
  pure function cum2rate_r( inarray, rate_unit ) result(rate_out)
    !> Input Output_Arrays array (real ::srp type)
    real(SRP), dimension(:), intent(in) :: inarray
    !> Optional rate parameter, the rate is calculated per this number of
    !! seconds, the default is per minute
    integer, intent(in), optional :: rate_unit

    real(SRP), dimension(:), allocatable :: rate_out

    integer :: rate_unit_loc, oarray_max, i, j

    real(SRP) :: sum_rate

    if (present(rate_unit)) then
      rate_unit_loc = rate_unit
    else
      rate_unit_loc = MINUTE
    end if

    oarray_max = size(inarray)   ! Output_Arrays
    allocate( rate_out(oarray_max/rate_unit_loc) )

    j = 0
    sum_rate = inarray(1)

    do i=2, oarray_max
      if( inarray(i) > inarray(i-1) ) then
        sum_rate = sum_rate + inarray(i) - inarray(i-1)
      end if
      if (mod(i,rate_unit_loc)==0) then
        j = j + 1
        rate_out(j) = sum_rate / real(rate_unit_loc,SRP)
        sum_rate = 0.0_SRP
      end if
    end do

  end function cum2rate_r

  !> Calculate rate based on simple block data, only the block start and
  !! end values are considered.
  !! @note This function is used to calculate the growth rate from body
  !!       size dynamics data.
  pure function blockrate ( inarray, rate_unit ) result (rate_out)
    !> Input Output_Arrays array (real ::srp type)
    real(SRP), dimension(:), intent(in) :: inarray
    !> Optional rate parameter, the rate is calculated per this number of
    !! seconds, the default is per minute
    integer, intent(in), optional :: rate_unit

    real(SRP), dimension(:), allocatable :: rate_out

    integer :: rate_unit_loc, iarray_max, i, j
    real(SRP) :: iarray_block_start, iarray_block_end

    if (present(rate_unit)) then
      rate_unit_loc = rate_unit
    else
      rate_unit_loc = MINUTE
    end if

    iarray_max = size(inarray)
    allocate( rate_out(iarray_max/rate_unit_loc) )

    j=1
    iarray_block_start = inarray(1)
    do i = 2, iarray_max
      if ( mod(i,rate_unit_loc)==0 ) then
        iarray_block_end = inarray(i)
        rate_out(j) = (iarray_block_end - iarray_block_start) /               &
                                                      real(rate_unit_loc,SRP)
        iarray_block_start = inarray(i)
        j=j+1
      end if
    end do

  end function blockrate

  !> Calculate an array of specific growth rate rate values based on simple
  !! block data,
  !! @note This function is identical as ::blockrate() but uses specific growth
  !!       rate calculated by ::sgr_i() function. In turn, sgr_i()
  !!       uses ::sgr_r() as the backend.
  pure function SGR_blockrate (inarray, rate_unit, time_unit) result (rate_out)
    !> Input Output_Arrays array (real ::srp type)
    real(SRP), dimension(:), intent(in) :: inarray
    !> Optional rate parameter, the rate is calculated per this number of
    !! seconds, the default is per minute
    integer, intent(in), optional :: rate_unit
    !> Logical flag determining if time in s should be converted to min
    integer, optional, intent(in) :: time_unit
    real(SRP), dimension(:), allocatable :: rate_out

    integer :: rate_unit_loc, iarray_max, i, j
    integer :: time_unit_loc
    real(SRP) :: iarray_block_start, iarray_block_end

    if (present(rate_unit)) then
      rate_unit_loc = rate_unit
    else
      rate_unit_loc = MINUTE
    end if

    if (present(time_unit)) then
      time_unit_loc = time_unit
    else
      time_unit_loc = 0
    end if

    iarray_max = size(inarray)
    allocate( rate_out(iarray_max/rate_unit_loc) )

    j=1
    iarray_block_start = inarray(1)
    do i = 2, iarray_max
      if ( mod(i,rate_unit_loc)==0 ) then
        iarray_block_end = inarray(i)
        rate_out(j) = SGR_i( iarray_block_end, iarray_block_start,            &
                             rate_unit_loc, 0, time_unit_loc)
        iarray_block_start = inarray(i)
        j=j+1
      end if
    end do

  end function SGR_blockrate

  !-----------------------------------------------------------------------------
  !> Simple history stack function, add to the end of the stack. We need
  !! only to add components on top of the stack and retain
  !! `commondata::history_size_spatial` elements of the prior history (for a
  !! spatial moving object). The stack works as follows, assuming 100 and 200
  !! are added:
  !! @n                [1 2 3 4 5 6 7  8   9  10];
  !! @n                [2 3 4 5 6 7 8  9  10 100];
  !! @n                [3 4 5 6 7 8 9 10 100 200]
  !! @param history_array Integer array that keeps the history.
  !! @param add_this we add this element to the end of the history array.
  !! @note This is the integer type version.
  pure subroutine add_to_history_i4(history_array, add_this)

    ! @param history_array Integer array that keeps the history.
    integer, dimension(:), intent(inout) :: history_array
    ! @param add_this we add this element to the end of the history array.
    integer, intent(in) :: add_this

    ! Local variable to keep the size of the history array
    integer :: history_size

    history_size = size(history_array)

    history_array = cshift(history_array,1)
    history_array(history_size) = add_this

  end subroutine add_to_history_i4

  !-----------------------------------------------------------------------------
  !> Simple history stack function, add to the end of the stack. We need
  !! only to add components on top of the stack and retain
  !! `commondata::history_size_spatial` elements of the prior history (for a
  !! spatial moving object).
  !! @param history_array Integer array that keeps the history.
  !! @param add_this we add this element to the end of the history array.
  !! @note This is the real type version.
  pure subroutine add_to_history_r(history_array, add_this)

    ! @param history_array Integer array that keeps the history.
    real(SRP), dimension(:), intent(inout) :: history_array
    ! @param add_this we add this element to the end of the history array.
    real(SRP), intent(in) :: add_this

    ! Local variable to keep the size of the history array.
    integer :: history_size

    history_size = size(history_array)

    history_array = cshift(history_array,1)
    history_array(history_size) = add_this

  end subroutine add_to_history_r

  !-----------------------------------------------------------------------------
  !> Simple history stack function, add to the end of the stack. We need
  !! only to add components on top of the stack and retain
  !! `commondata::history_size_spatial` elements of the prior history.
  !! @param history_array Integer array that keeps the history.
  !! @param add_this we add this element to the end of the history array.
  !! @note This is the character string type version
  pure subroutine add_to_history_char(history_array, add_this)

    ! @param history_array Integer array that keeps the history.
    character(*), dimension(:), intent(inout) :: history_array
    ! @param add_this we add this element to the end of the history array.
    character(*), intent(in) :: add_this

    ! Local variable to keep the size of the history array.
    integer :: history_size

    history_size = size(history_array)

    history_array = cshift(history_array,1)
    history_array(history_size) = add_this

  end subroutine add_to_history_char

  !> Return the last value in the array. Note that this function is especially
  !! useful for long nested objects, to avoid complex `set`.
  pure function last_in_history_r ( history_array, offset ) result (last_value)
    real(SRP), dimension(:), intent(in) :: history_array
    integer, optional, intent(in) ::  offset
    real(SRP) :: last_value

    integer :: offset_loc

    if (present(offset)) then
      offset_loc = offset
      ! offset must not go beyond the actual array limits
      if (offset_loc > size(history_array)-1) then
        offset_loc = size(history_array)-1
      else if (offset_loc < 0) then
        offset_loc = 0
      end if
    else
      offset_loc = 0
    end if

    last_value = history_array( size(history_array)-offset_loc )

  end function last_in_history_r

  !> Return the last value in the array. Note that this function is especially
  !! useful for long nested objects, to avoid complex `set`.
  pure function last_in_history_i4 (history_array, offset) result (last_value)
    integer, dimension(:), intent(in) :: history_array
    integer, optional, intent(in) ::  offset
    integer :: last_value

    integer :: offset_loc

    if (present(offset)) then
      offset_loc = offset
      ! offset must not go beyond the actual array limits
      if (offset_loc > size(history_array)-1) then
        offset_loc = size(history_array)-1
      else if (offset_loc < 0) then
        offset_loc = 0
      end if
    else
      offset_loc = 0
    end if

    last_value = history_array( size(history_array)-offset_loc )

  end function last_in_history_i4

  !> Return the last value in the array. Note that this function is especially
  !! useful for long nested objects, to avoid complex `set`.
  pure function last_in_history_char (history_array, offset) result(last_value)
    character(*), dimension(:), intent(in) :: history_array
    integer, optional, intent(in) ::  offset
    character(len=:), allocatable :: last_value

    integer :: offset_loc

    if (present(offset)) then
      offset_loc = offset
      ! offset must not go beyond the actual array limits
      if (offset_loc > size(history_array)-1) then
        offset_loc = size(history_array)-1
      else if (offset_loc < 0) then
        offset_loc = 0
      end if
    else
      offset_loc = 0
    end if

    last_value = history_array( size(history_array)-offset_loc )

  end function last_in_history_char

  !-----------------------------------------------------------------------------
  !> Force a value within the range set by the vmin and vmax dummy parameter
  !! values. If the value is within the range, it does not change, if it
  !! falls outside, the output force value is obtained as
  !! min( max( value, FORCE_MIN ), FORCE_MAX )
  !! @param[in] value_in Input value for forcing transformation.
  !! @param[in] vmin minimum value of the force-to range (lower limit), if
  !!            not present, a lower limit of 0.0 is used.
  !! @param[in] vmax maximum value of the force-to range (upper limit)
  !! @returns   an input value forced to the range.
  !! @note      Note that this is the **real** precision version of the
  !!            generic `within` function.
  elemental function within_r(value_in, vmin, vmax) result (value_out)
    real(SRP), intent(in) :: value_in
    real(SRP), optional, intent(in) :: vmin
    real(SRP), intent(in) :: vmax
    real(SRP) :: value_out

    ! Local copies of optionals.
    real(SRP) :: vmin_here

    ! Check optional minimum value, if absent, set to a default value 0.0.
    if (present(vmin)) then
      vmin_here =  vmin
    else
      vmin_here = 0.0_SRP
    end if

    value_out = min( max( value_in, vmin_here ), vmax )

  end function within_r

  !-----------------------------------------------------------------------------
  !> Force a value within the range set by the vmin and vmax dummy parameter
  !! values. If the value is within the range, it does not change, if it
  !! falls outside, the output force value is obtained as
  !! min( max( value, FORCE_MIN ), FORCE_MAX )
  !! @param[in] value_in Input value for forcing transformation.
  !! @param[in] vmin minimum value of the force-to range (lower limit), if
  !!            not present, a lower limit of 0.0 is used.
  !! @param[in] vmax maximum value of the force-to range (upper limit)
  !! @returns   an input value forced to the range.
  !! @note      Note that this is the **integer** version of the generic
  !!            `within` function.
  elemental function within_i(value_in, vmin, vmax) result (value_out)
    integer, intent(in) :: value_in
    integer, optional, intent(in) :: vmin
    integer, intent(in) :: vmax
    integer :: value_out

    ! Local copies of optionals.
    integer :: vmin_here

    ! Check optional minimum value, if absent, set to a default value 0.0.
    if (present(vmin)) then
      vmin_here =  vmin
    else
      vmin_here = 0.0_SRP
    end if

    ! Calculate the force-limit output value.
    value_out = min( max( value_in, vmin_here ), vmax )

  end function within_i

  !> Function calculating standard oxygen consumption in rainbow trout
  !! based on the empirical curve defined by interpolation on the grid
  !! determined by two global arrays:
  !!
  !!  - commondata::global_oxygen_grid_x_temp -- `smr_oxygen_temp`
  !!  - commondata::global_oxygen_grid_y_o2std -- `smr_oxygen_o2`
  !!  .
  !!
  !! For rainbow trout, the data are based on Evans, D.O. (1990)
  !! Metabolic Thermal compensation by rainbow trout: effects on
  !! standard metabolic rate and potential usable power.
  !! Trans. Am. Fish. Soc. 119, 585–600, Fig. 9:
  !!
  !! Variable         |1    |2    |3    |4    |5    |6     |7
  !! -----------------|-----|-----|-----|-----|-----|------|-------
  !! Temperature ºC   |0.0  |0.5  |5.1  |15.2 |20.2 |25.2  |26.2
  !! SMR              |38.0 |38.0 |40.6 |67.8 |94.6 |136.7 |145.9
  !!
  !! Interpolation data from Evan 1990:
  !!@verbatim
  !!  [0.0 0.5 5.1 15.2 20.2 25.2 26.2]
  !!  [38.0 38.0 40.6 67.8 94.6 136.7 145.9]
  !!@endverbatim
  !!
  !! @note Note that this function uses `CSPLINE` cubic spline interpolation
  !!       function from `BASE_UTILS`.
  pure function oxygen_rate_std_spline(temperature) result (o2rate)
    use BASE_UTILS, only : CSPLINE
    !> Temperature Celsius. Note that temperature is an array
    real(SRP), dimension(:), intent(in) :: temperature
    !> Standard Oxygen consumption @f$ mg \; O_2 \; kg ^{-1} \; h^{-1} @f$
    !! array for the respective input temperatures
    real(SRP), allocatable, dimension(:)  :: o2rate

    real(SRP), dimension( size(temperature) ) :: outval

    call CSPLINE ( Global_Oxygen_Grid_X_Temp, Global_Oxygen_Grid_Y_O2std,     &
                   temperature, outval )

    o2rate =  outval

  end function oxygen_rate_std_spline

  !> Function calculating standard oxygen consumption in rainbow trout
  !! based on the empirical curve defined by interpolation on the grid
  !! determined by two global arrays:
  !!
  !!  - commondata::global_oxygen_grid_x_temp -- `smr_oxygen_temp`
  !!  - commondata::global_oxygen_grid_y_o2std -- `smr_oxygen_o2`
  !!  .
  !!
  !! For rainbow trout, the data are based on Evans, D.O. (1990)
  !! Metabolic Thermal compensation by rainbow trout: effects on
  !! standard metabolic rate and potential usable power.
  !! Trans. Am. Fish. Soc. 119, 585–600, Fig. 9:
  !!
  !! Variable         |1    |2    |3    |4    |5    |6     |7
  !! -----------------|-----|-----|-----|-----|-----|------|-------
  !! Temperature ºC   |0.0  |0.5  |5.1  |15.2 |20.2 |25.2  |26.2
  !! SMR              |38.0 |38.0 |40.6 |67.8 |94.6 |136.7 |145.9
  !!
  !! Interpolation data from Evan 1990:
  !!@verbatim
  !!  [0.0 0.5 5.1 15.2 20.2 25.2 26.2]
  !!  [38.0 38.0 40.6 67.8 94.6 136.7 145.9]
  !!@endverbatim
  !!
  !! @note Note that this function uses `CSPLINE_SCALAR` cubic splines
  !!       interpolation function from `BASE_UTILS`.
  pure function oxygen_rate_std_ddpi(temperature) result (o2rate)
    use BASE_UTILS, only : CSPLINE_SCALAR
    !> Temperature Celsius
    real(SRP), intent(in) :: temperature
    !> Standard Oxygen consumption @f$ mg \; O_2 \; kg ^{-1} \; h^{-1} @f$
    real(SRP) :: o2rate

    o2rate =  CSPLINE_SCALAR( Global_Oxygen_Grid_X_Temp,                      &
                           Global_Oxygen_Grid_Y_O2std, temperature )

  end function oxygen_rate_std_ddpi

  !> Function to calculate the FCR, feed conversion rate
  !! @f$ FCR = \frac{F} {\Delta M} @f$
  elemental function FCR(input_f, output_m) result (fcr_out)
    !> Feed mass
    real(SRP), intent(in) :: input_f
    !> Body mass increment
    real(SRP), intent(in) :: output_m
    !> Feed conversion rate (FCR)
    real(SRP) :: fcr_out

    fcr_out = input_f / output_m

  end function FCR

  !> Convert kg to g
  elemental function kg2g(kg) result (g)
    real(SRP), intent(in) :: kg
    real(SRP) :: g

    g = 1000.0_SRP * kg

  end function kg2g

  !> Convert g to kg
  elemental function g2kg(g) result (kg)
    real(SRP), intent(in) :: g
    real(SRP) :: kg

    kg = g / 1000.0_SRP

  end function g2kg

  !> Convert kg to mg
  elemental function kg2mg(kg) result (mg)
    real(SRP), intent(in) :: kg
    real(SRP) :: mg

    mg = 1000000.0_SRP * kg

  end function kg2mg

  !> Convert mg to kg
  elemental function mg2kg(mg) result (kg)
    real(SRP), intent(in) :: mg
    real(SRP) :: kg

    kg = mg / 1000000.0_SRP

  end function mg2kg

  !> Convert mg to g
  elemental function mg2g(mg) result (g)
    real(SRP), intent(in) :: mg
    real(SRP) :: g

    g = mg / 1000.0_SRP

  end function mg2g

  !> Convert g to mg
  elemental function g2mg(g) result (mg)
    real(SRP), intent(in) :: g
    real(SRP) :: mg

    mg = g * 1000.0_SRP

  end function g2mg

  !> Convert micro (\mu) unit to unit, e.g. from micro mol to mol
  !! Metric prefix micro = 10^-6: unit x 0.000 001
  elemental function from_micro(mu_unit) result (unit)
    real(SRP), intent(in) :: mu_unit
    real(SRP) :: unit

    unit = mu_unit * 0.000001_SRP

  end function from_micro

  !> Calculates specific growth rate following Houde & Schekter (1981):
  !! @f[ G = ( e^{ \frac{ ln W_2 - ln W_1 }{ t_2 - t_1 } } -1 ) 100 @f]
  !! @note Note that this function is the main computation backend that
  !!       is called in ::sgr_i() and ::sgr_blockrate().
  elemental function SGR_r( weight1, weight2, time1, time2 ) result (sgr_out)
    !> Body weight at start of the time interval
    real(SRP), intent(in) :: weight1
    !> Body weight at the end of the time interval
    real(SRP), intent(in) :: weight2
    !> Time at the start of the time interval
    real(SRP), intent(in) :: time1
    !> Time at the end of the time interval
    real(SRP), intent(in) :: time2
    real(SRP) :: sgr_out

    sgr_out = ( exp( ( log(weight2) - log(weight1) ) /                        &
                            ( time2 - time1)             ) - 1 ) * 100.0_SRP

  end function SGR_r

  !> Calculates specific growth rate following Houde & Schekter (1981):
  !! @f[ G = ( e^{ \frac{ ln W_2 - ln W_1 }{ t_2 - t_1 } } -1 ) 100 @f]
  !! @note Note that the `is_convert_min` (optional) parameter is useful to
  !!       convert the time step data (s) to min.
  !! @note Note that this function uses ::sgr_r() as the backend.
  elemental function SGR_i(weight1, weight2, time1, time2, time_unit)         &
                                                              result (sgr_out)
    !> Body weight at start of the time interval
    real(SRP), intent(in) :: weight1
    !> Body weight at the end of the time interval
    real(SRP), intent(in) :: weight2
    !> Time at the start of the time interval
    integer, intent(in)   :: time1
    !> Time at the end of the time interval
    integer, intent(in)   :: time2
    !> If the two time parameters `time1` and `time2` are provided in raw
    !! model time units (s), this parameter allows to rescale these raw units
    !! to commondata::minute or commondata::hour.
    !! @note If time units are provided in any other measures than raw time
    !!       steps (s), this `time_unit`parameter should be set to default
    !!       value or out of normal range (e.g. -1). Then the rate unit will
    !!       use the same time scale as `time1` and `time2`. Notably, this
    !!       should ber done if the times are given in commondata::hour.
    integer, optional, intent(in) :: time_unit
    real(SRP) :: sgr_out

    integer :: time_unit_loc

    if (present(time_unit)) then
      time_unit_loc = time_unit
    else
      time_unit_loc = 0
    end if

    if ( time_unit_loc > 1 ) then
      sgr_out=SGR_r(weight1, weight2, real(time1,SRP)/real(time_unit_loc,SRP),&
                                      real(time2,SRP)/real(time_unit_loc,SRP) )
    else
      sgr_out=SGR_r(weight1, weight2, real(time1,SRP), real(time2,SRP) )
    end if

  end function SGR_i

  !> Define the default stomach emptying data structure
  !! ::stomach_emptying_pattern in case the input data
  !! from a CSV file are absent.
  pure function stomach_emptying_def_default() result (pattern_def)
    type(STOMACH_EMPTYING_PATTERN) :: pattern_def

    real(SRP), parameter, dimension(*) ::                           &
                MASS_GRID = [ 50.0_SRP,  100.0_SRP, 300.0_SRP, 500.0_SRP ]

    real(SRP), parameter, dimension(*) ::                           &
                TEMP_GRID = [ 5.0_SRP, 10.0_SRP, 15.0_SRP, 20.0_SRP, 22.0_SRP ]

    integer, parameter ::   LEVELS_MASS = size(MASS_GRID),                    &
                            LEVELS_TEMP = size(TEMP_GRID)

    integer, parameter, dimension(LEVELS_MASS, LEVELS_TEMP) ::                &
                                          EMPTYING_GRID_HOUR = reshape (      &
   ! ..........................................................................
   !                                50  100  300  500
                           [ &    !  1    2    3    4      LEVELS_MASS
                                  !----------------------------
                                    24,  35,  75, 100,     & ! 1   5 LEVELS_TEMP
                                    15,  20,  50,  75,     & ! 2  10
                                     9,  15,  40,  50,     & ! 3  15
                                     5,  10,  30,  35,     & ! 4  20
                                     4,   8,  29,  33   ], & ! 5  22
                                  !-----------------------------
                    [LEVELS_MASS, LEVELS_TEMP],   [0],      [1,2] )
  ! Note: additional     array  shape           | pad    |  order
  !       reshape params:                       | with   |  by rows
  ! ...........................................................................

  pattern_def%grid_mass = MASS_GRID
  pattern_def%grid_temperature = TEMP_GRID
  pattern_def%emptying_time = EMPTYING_GRID_HOUR * HOUR

  end function stomach_emptying_def_default

  !> Show the stomach emptying data structure.
  impure function stomach_emptying_txt(is_raw_s) result (message_show)
    character(len=:), allocatable :: message_show
    logical, optional, intent(in) :: is_raw_s

    integer :: i,j
    logical is_raw_loc
    character(len=50) :: msg
    character(len=*), parameter :: FMT_REAL="f9.2", COLSEP="  |",             &
                                    FMT_INT="I9"
    integer :: FMT_LEN = 9 ! coincides with total length of FMT_REAL
    character(len=:), allocatable :: fmtstr, fmtint

    if (present(is_raw_s)) then
      is_raw_loc = is_raw_s
    else
      is_raw_loc = .FALSE.
    end if

    fmtstr = "(" // FMT_REAL // ")"
    fmtint = "(" // FMT_INT // ")"

    ! Title text
    message_show = "Stomach emptying time (h) parameter matrix:" // CRLF

    ! First header line
    message_show = message_show // "         " // COLSEP //                   &
                   "  BODY MASS:" // CRLF

    ! Write the first row of body mass grid array
    message_show = message_show // "     TEMP" // COLSEP
    do i=1, size( Global_Stomach_Emptying_Pattern%grid_mass )
      write(msg,fmtstr) Global_Stomach_Emptying_Pattern%grid_mass(i)
      message_show = message_show // trim(msg)
    end do
    ! Write horizontal separator line
    message_show = message_show // CRLF // repeat("-",FMT_LEN) // "--+" //    &
     repeat("-", size(Global_Stomach_Emptying_Pattern%grid_mass)*FMT_LEN)//CRLF

    ! Write the main body of the data
    do j=1, size(Global_Stomach_Emptying_Pattern%grid_temperature)
      ! Each line starts with the temperature grid array value
      write(msg,fmtstr) Global_Stomach_Emptying_Pattern%grid_temperature(j)
      message_show = message_show // trim(msg) // COLSEP
      ! Normal data follow
      do i=1, size( Global_Stomach_Emptying_Pattern%grid_mass )
        if (is_raw_loc) then
          write(msg,fmtint) Global_Stomach_Emptying_Pattern%emptying_time(i,j)
        else
          write(msg,fmtstr)                                                   &
            real(Global_Stomach_Emptying_Pattern%emptying_time(i,j),SRP) / HOUR
        end if
        message_show = message_show // trim(msg)
      end do
      message_show = message_show // CRLF ! end of row
    end do

  end function stomach_emptying_txt

  !> Produce a formatted text string containing the adjusted stomach
  !! transport arrays commondata::global_transport_pattern_r and
  !! commondata::global_transport_pattern_t
  impure function stomach_transport_txt(adjust, format, show, prefix)         &
                                                                result(txt_out)
    use BASE_UTILS, only: TOSTR
    use BASE_STRINGS, only: UPPERCASE
    character(len=:), allocatable :: txt_out
    !> Optional adjustment factor for the array
    !! commondata::global_transport_pattern_t
    real(SRP), optional, intent(in) :: adjust
    !> Optional format for the output arrays: "R" for R style, "python" for
    !! the Python style, default is the python style.
    character(len=*), optional, intent(in) :: format
    !> Default selection of what array to show,
    !! `transport_pattern_t` or `transport_pattern_r`.
    character(len=*), optional, intent(in) :: show
    !> Optional prefix string that comes before the array on left.
    character(len=*), optional, intent(in) :: prefix

    enum, bind(C)
      enumerator :: SHOW_P, SHOW_T, SHOW_PT
    end enum

    real(SRP), dimension( size(Global_Transport_Pattern_R) ) :: stpr
    integer, dimension( size(Global_Transport_Pattern_T) ) :: stpt
    real(SRP) :: adjust_loc
    character(len=*), parameter :: FMTSTR = "(f6.2)"
    integer :: i, what
    character(len=:), allocatable :: sep_l, sep_r, & ! array delimiters
                                     prefl

    if (present(adjust)) then
      adjust_loc = adjust
    else
      adjust_loc = 1.0_SRP
    end if

    if (present(format)) then
      if (UPPERCASE(format)=="R") then
        sep_l="c("
        sep_r=")"
      elseif (UPPERCASE(format)=="PYTHON") then
        sep_l="["
        sep_r="]"
      end if
    else  ! default is Python style
        sep_l="["
        sep_r="]"
    end if

    if (present(show)) then
      ! transport_pattern_t
      if (UPPERCASE(show)=="TRANSPORT_PATTERN_T") then
        what=SHOW_T
      ! transport_pattern_r
      elseif (UPPERCASE(show)=="TRANSPORT_PATTERN_R") then
        what=SHOW_P
      ! Both transport_pattern_t and transport_pattern_r
      elseif (UPPERCASE(show)=="BOTH") then
        what = SHOW_PT
      end if
    ! Default is both transport_pattern_t and transport_pattern_r
    else
      what = SHOW_PT
    end if

    if (present(prefix)) then
      prefl = prefix
    else
      prefl = ""
    end if

    stpr = Global_Transport_Pattern_R
    stpt = Global_Transport_Pattern_T * adjust_loc

    if (what == SHOW_PT .or. what==SHOW_T) then

      txt_out = prefl // "transport_pattern_t = " // sep_l ! [

      do i=1, size(stpt)-1
        txt_out = txt_out // TOSTR(stpt(i)) // ", "
      end do
      txt_out = txt_out // TOSTR(stpt(size(stpt)))

      txt_out = txt_out // sep_r

      if (what==SHOW_PT) txt_out = txt_out // CRLF

    else
      txt_out = ""
    end if

    if (what==SHOW_PT .or. what==SHOW_P) then

      txt_out = txt_out // prefl // "transport_pattern_r = " // sep_l

      do i=1, size(stpr)-1
        txt_out = txt_out // TOSTR(stpr(i),FMTSTR) // ", "
      end do
      txt_out = txt_out // TOSTR(stpr(size(stpr)),FMTSTR)

      txt_out = txt_out // sep_r

    end if

  end function stomach_transport_txt

end module COMMONDATA
